# Generated by Django 3.0.6 on 2020-11-20 14:01

from django.conf import settings
import django.contrib.auth.models
import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0011_update_proxy_permissions'),
    ]

    operations = [
        migrations.CreateModel(
            name='Abiturient',
            fields=[
                ('user_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to=settings.AUTH_USER_MODEL)),
                ('middle_name', models.CharField(blank=True, max_length=30)),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'abstract': False,
            },
            bases=('auth.user',),
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='Attempt',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('has_accepted', models.BooleanField(default=False)),
                ('has_original_document', models.BooleanField(default=False)),
                ('abiturient', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attempts', to='abitura.Abiturient')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EducationForm',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=128)),
                ('code', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EducationProgram',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=128)),
                ('code', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='EducationProgramInstance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('duration_years', models.PositiveSmallIntegerField(default=4)),
                ('subjects', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=32), size=None)),
                ('career', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=32), size=None)),
                ('education_form', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='education_programs', to='abitura.EducationForm')),
                ('education_program', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='program_instances', to='abitura.EducationProgram')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Graduation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=128)),
                ('code', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProgramDirection',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=128)),
                ('code', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProgramDirectionRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('year', models.SmallIntegerField()),
                ('places_count', models.SmallIntegerField(default=0)),
                ('program_direction', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='direction_relations', to='abitura.ProgramDirection')),
                ('program_instance', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='direction_relations', to='abitura.EducationProgramInstance')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Subject',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=128)),
                ('code', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubjectScore',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('type', models.CharField(choices=[('EXAM', 'Exam'), ('MINIMAL_REQUIREMENT', 'Minimal Requirement')], default='EXAM', max_length=32)),
                ('value', models.PositiveSmallIntegerField()),
                ('attempt', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='exams', to='abitura.Attempt')),
                ('direction_relation', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='requirements', to='abitura.ProgramDirectionRelation')),
                ('subject', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='rates', to='abitura.Subject')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='educationprograminstance',
            name='graduation',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='program_instances', to='abitura.Graduation'),
        ),
        migrations.AddField(
            model_name='educationprograminstance',
            name='program_directions',
            field=models.ManyToManyField(related_name='program_instances', through='abitura.ProgramDirectionRelation', to='abitura.ProgramDirection'),
        ),
        migrations.AddField(
            model_name='attempt',
            name='direction',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attempts', to='abitura.ProgramDirectionRelation'),
        ),
    ]
